package org.greenstone.gsdl3.gs3build.metadata;

public class METSAgent
{
	String name;
	String note;

	String role;
	String otherrole;
	String type;
	String othertype;

	public METSAgent(String name, String note, String role, String type)
	{	this.name = name;
		this.note = note;

		this.setRole(role);
		this.setType(type);
	}

	/**
	 *  Check if the role matches one of the standard offerings
	 */
	private boolean validateRole(String role)
	{	return true;
	}

	/**
	 *  Check if the type matches one of the standard offerings
	 */
	private boolean validateType(String role)
	{	if (role.equals("INDIVIDUAL") ||
		    role.equals("ORGANIZATION")) {
			return true;
		}
		return false;
	}

	public void setRole(String otherRole)
	{	// automatically use 'OTHER' if either the role or type of agent don't
		// validate against the standard list
		if (this.validateRole(role)) {
			this.role = role;
			this.otherrole = null;
		}
		else {
			this.role = "OTHER";
			this.otherrole = role;
		}
	}

	public void setType(String otherType)
	{	// automatically use 'OTHER' if either the role or type of agent don't
		// validate against the standard list
		if (this.validateType(type)) {
			this.type = type;
			this.othertype = null;
		}
		else {
			this.type = "OTHER";
			this.othertype = type;
		}
	}
}